//! @file stk_525.c,v
//!
//! 쌠 (c) 2004 Atmel.
//!
//! 쌠ʒmɂĂlicense.txţقǂ݂B
//!
//! @brief ̧قA/Dϊp̒ʊ֐܂݂܂B
//!
//! @version 1.3 at90usb128-demo-hidgen-1_0_0 $Id: stk_525.c,v 1.3 2006/03/14 15:36:00 rletendu Exp $
//!
//! @todo
//! @bug

//_____ ݸٰ ______________________________________________________________

#include "config.h"
#include "stk_525.h"

#ifdef USE_ADC			//!< ̒`config.ḩقŐݒ肳܂B
#include "lib_mcu\adc\adc_drv.h"

//_____ ϸ __________________________________________________________________

//_____ I錾 _____________________________________________________________

//_____ ` _________________________________________________________________

//! ȉ̕\A/DϊƉxƂ̊Ԃ̑Ή^܂B\̊evfA/Dϊ
//! lɑΉ܂B\̎wW͎őΉ鉷x()^܂Bx=wW-20
//! \[0]-20̉xɑΉ܂Bȉ̕\Vcc=3.3VAAref=AVccɑ΂
//! A/Dϊ^܂B
code U16 temperature_code[]={
	0x3B4,0x3B0,0x3AB,0x3A6,0x3A0,0x39A,0x394,0x38E,0x388,0x381,0x37A,0x373,
	0x36B,0x363,0x35B,0x353,0x34A,0x341,0x338,0x32F,0x325,0x31B,0x311,0x307,
	0x2FC,0x2F1,0x2E6,0x2DB,0x2D0,0x2C4,0x2B8,0x2AC,0x2A0,0x294,0x288,0x27C,
	0x26F,0x263,0x256,0x24A,0x23D,0x231,0x225,0x218,0x20C,0x200,0x1F3,0x1E7,
	0x1DB,0x1CF,0x1C4,0x1B8,0x1AC,0x1A1,0x196,0x18B,0x180,0x176,0x16B,0x161,
	0x157,0x14D,0x144,0x13A,0x131,0x128,0x11F,0x117,0x10F,0x106,0x0FE,0x0F7,
	0x0EF,0x0E8,0x0E1,0x0DA,0x0D3,0x0CD,0x0C7,0x0C0,0x0BA,0x0B5,0x0AF,0x0AA,
	0x0A4,0x09F,0x09A,0x096,0x091,0x08C,0x088,0x084,0x080,0x07C,0x078,0x074,
	0x071,0x06D,0x06A,0x067,0x064,0x061,0x05E,0x05B,0x058,0x055,0x053,0x050,
	0x04E,0x04C,0x049,0x047,0x045,0x043,0x041,0x03F,0x03D,0x03C,0x03A,0x038};

//_____ 錾 _________________________________________________________________

U16 Get_adc_mic_val (void)
{
	Start_conv_channel(ADC_MIC_CH);
	while (!Is_adc_conv_finished());
	return (U16)(ADCL+((U16)(ADCH<<8)));
}

U16 Get_adc_pot_val (void)
{
	Start_conv_channel(ADC_POT_CH);
	while (!Is_adc_conv_finished());
	return (U16)(ADCL+((U16)(ADCH<<8)));
}

U16 Get_adc_temp_val (void)
{
	Start_conv_channel(ADC_TEMP_CH);
	while (!Is_adc_conv_finished());
	return (U16)(ADCL+((U16)(ADCH<<8)));
}

S16 Read_temperature (void)
{
#ifndef AVRGCC
	U16 adc_code;
	S8 index=0;
	adc_code=Get_adc_temp_val();
	if(adc_code>temperature_code[0])
	{
		return (S16)(-20);
	}
	else
	{
		while(temperature_code[index++]>adc_code);
		return (S16)(index-1-20);
	}
#else
	U16 adc_code;
	S8 index=0;
	adc_code=Get_adc_temp_val();
	if(adc_code>pgm_read_word_near(&temperature_code))
	{
		return (S16)(-20);
	}
	else
	{
		while(pgm_read_word_near(&temperature_code[index++])>adc_code);
		return (S16)(index-1-20);
	}
#endif
}

#endif // USE_ADC
