//!
//! @file hid_task.c,v
//!
//! 쌠 (c) 2004 Atmel.
//!
//! 쌠ʒmɂĂlicense.txţقǂ݂B
//!
//! @brief ̧ق͕WHIDo͍ƂǗ܂B
//!
//!
//! @version 1.4 at90usb128-demo-hidgen-1_0_0 $Id: hid_task.c,v 1.4 2006/03/17 13:06:34 rletendu Exp $
//!
//! @todo
//! @bug
//!/

//_____ ݸٰ ____________________________________________________________

#include "config.h"
#include "conf_usb.h"
#include "hid_task.h"
#include "lib_board/stk_525/stk_525.h"
#include "lib_mcu\usb\usb_drv.h"
#include "usb_descriptors.h"
#include "modules\usb\device_chap9\usb_standard_request.h"
#include "usb_specific_request.h"
#include "lib_mcu\adc\adc_drv.h"

//_____ ϸ ________________________________________________________________

//_____ ` _______________________________________________________________

//_____ 錾 _______________________________________________________________

extern bit usb_connected;
extern U8 usb_configuration_nb;
volatile U8 cpt_sof=0;

//! USBް۰ޓ_ւ̊֐߲錾
void (*start_bootloader) (void)=(void (*)(void))0xf000;

//!
//! @brief ̊֐͖ړIΏۊ̎܂B
//!
//! @warning Code:??޲(֐ޒ)
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
//!/
void hid_task_init (void)
{
	init_adc();
	Leds_init();
	Joy_init();
}

//! @brief HIDWʐMƂ̓_
//!
//! ̊֐IN/OUT񍐊ǗǗ܂B
//!
//! @warning Code:??޲(֐ޒ)
//!
//! @param	Ȃ
//!
//! @return	Ȃ
void hid_task (void)
{
	U8 dummy;
	U8 dummy2;
	U8 volatile pot;
	U8 volatile tempe;
	U8 joy;
	U32 volatile tempo;

	if(Is_device_enumerated())				//! USB HID(ڑF)ꂽ
	{
		Usb_select_endpoint(EP_HID_OUT);	//! νĂް񍐎擾
		if(Is_usb_receive_out())
		{
			Leds_set_val(Usb_read_byte());	//! OUT[0]񍐂LEDl
			GPIOR1=Usb_read_byte();			//! (sgp)
			GPIOR1=Usb_read_byte();			//! (sgp)
			dummy=Usb_read_byte();			//! ޲ĂƂ̑gݍ킹DFU쎖ۈڍsoνĂɋ܂B
			dummy2=Usb_read_byte();
			Usb_ack_receive_out();
		}

		if(dummy==0x55 && dummy2==0xAA)		//! νĂDFUM
		{
			Usb_detach();					//! ۂ̕WHIDpt
			for(tempo=0;tempo<70000;tempo++);	//! ̑OɈ鎞ԑҋ@
			(*start_bootloader)();			//! ް۰ނ֔
		}
		tempe=(S8)Read_temperature();		//! A/Dϊ킩牷xl擾
		tempe=(S8)Read_temperature();
		tempe=(S8)Read_temperature();

		pot= Get_adc_pot_val()>>2;			//! A/Dϊ킩ϒRʒu擾
		pot= Get_adc_pot_val()>>2;			//! (xmƊO߰ݽقȂ邽3擾)
		pot= Get_adc_pot_val()>>2;

		joy=0;								//! ޮè\z
		if(Is_joy_up())						//! ی
		{
			joy+=0x01;
		}
			if(Is_joy_down())				//! ی
		{
			joy+=0x02;
		}
			if(Is_joy_right())				//! ی
		{
			joy+=0x04;
		}
			if(Is_joy_left())				//! ی
		{
			joy+=0x08;
		}
		Usb_select_endpoint(EP_HID_IN);		//! νĉpւ̏̑o
		if(Is_usb_in_ready())
		{
			Usb_write_byte(Leds_get_val());	//! LED
			Usb_write_byte(joy);			//! ޮè
			Usb_write_byte(pot);			//! ϒR
			Usb_write_byte(tempe);			//! x
			Usb_write_byte(GPIOR1);			//! U(sgp)
			Usb_write_byte(~PINE);			//! U(sgp)
			Usb_write_byte(~PINE);			//! U(sgp)
			Usb_write_byte(~PINE);			//! U(sgp)
			Usb_ack_fifocon();				//! USBްo
		}
	}
}

//! @brief sof_action
//!
//! ̊֐USBڰъJn荞ݻٰ݂s(1ms)cpt_sofv
//! ܂B
//! ԒxǗɗLpłB
//!
//! @warning Code:??޲(֐ޒ)
//!
//! @param	Ȃ
//!
//! @return	Ȃ
void sof_action()
{
	cpt_sof++;
}
